load data					% Load data from file
whos						% Show variables

figure(1)
plot(WavelengthsX,X'), title('Measured X')	% Plot measured X

[U,S,V]=svd(X);					% X=U*S*V'

T=U*S;						% Calculate T and P:
P=V;						% X=T*P'
figure(2)
plot(P(:,1:3)), title('Three first loadings')	% Plot the first loadings

figure(3)
bar(diag(S)), title('Singular values');		% Plot singular values
Aopt=input('Number of components to use: ');	% Deside number of comp.
T=T(:,1:Aopt);					% Remove uninteresting
P=P(:,1:Aopt);					% parts of T and P.
Xhat=T*P';					% Construct estimated X	

figure(4)
plot(WavelengthsX,X')				% Plot measured X together
hold on						% with constructed X.
plot(WavelengthsX,Xhat','.')
legend('-','measured','.','reconstructed')
hold off					% Turn off hold
	
figure(5)
plot(WavelengthsX,Xhat'-X')			% Plot the difference
title('Deviation from measured X')		% between X and Xhat
