% File: CalDirIn.m
% Purpose: Demostrate direct and indirect calibration


clear all
load litmusal
whos
[nObj,nXVar]=size(X);
y=Y(:,1);

% Direct calibration:
% Model: X = CK' + E
 
CDirHat=X*PureK'*inv(PureK*PureK');


CDirHat =(CDirHat(:,1)+CDirHat(:,2))*100;
EDir=y-CDirHat;
rDir=corrcoef(CDirHat(:,1),y);
rDir=rDir(1,2)


% Indirect calibration:
% Model: X=xmean + TP' + E, T=XP,y=ymean + tq'+f

MeanX=mean(X);
Meany=mean(y);

XCentered=X-ones(nObj,1)*MeanX;
yCentered=y-Meany;

[U,S,P]=svd(XCentered,0);
Sing=diag(S)';
Sing=Sing(1:10)
AOpt=input('AOpt')
T=U(:,1:AOpt)*S(1:AOpt,1:AOpt);
q=yCentered'*T*inv(T'*T);
yIndirHat=Meany + T*q';
fIndir=y-yIndirHat;

rIndir=corrcoef(yIndirHat,y);
rIndir=rIndir(1,2)

figure(1),clg
plot(y,CDirHat,'*')
hold on,plot(y,yIndirHat,'ro')
title(['yHat vs y: *=Dir,r=',num2str(rDir),' ,o=Indir.,r=',num2str(rIndir)])
axis([-10 110 -10 110])


figure(2),clg
plot(EDir,'*')
hold on ,plot(fIndir,'ro'),title('Error in yHat: yel.=Direct,red=Indirect cal.')
